-- Pravimo listu prvih n elemenata harmonijskog reda (n>0)
-- ukoliko je n = 1, vracamo listu koja sadrzi prvi element harmonijskog reda
-- inace pozovemo funkciju rekurzivno za n-1
-- i na rezultat nadovezemo reciprocnu vrednost broja n
harm n
  | n == 1 = [1.0]
  | otherwise = harm (n-1) ++ [recip n]

-- Pravimo listu delioca broja n
-- ukoliko je n = 1, vracamo listu koja sadrzi samo 1
-- inace pozivamo pomocnu funkciju sa jos jednim parametrom
-- koji nam govori do kog potencijalnog delioca smo stigli
delioci n
    | n == 1 = [1]
    | otherwise = delioci1 n 2

-- Pravimo listu delioca broja n pocev od broja k
-- ukoliko smo stigli do broja n (k==n) vracamo praznu listu
-- inace proveravamo da li je k delioc broja n
-- ako jeste, stavljamo ga u listu i pozivamo funkciju rekurzivno
-- za k+1 (sledeci potencijalni delilac)
-- inace samo pozivamo funkciju rekurzivno za k+1
delioci1 n k
    | k == n = []
    | n `mod` k == 0 = [k] ++ (delioci1 n (k+1))
    | otherwise = delioci1 n (k+1)

-- Nadovezujemo listu2 na listu1 n puta
-- ukoliko je n == 1 na listu1 nadovezemo listu2 operatorom ++
-- inace pozovemo funkciju rekurzivno za n-1 i na rezultat nadovezemo listu2
nadovezi lista1 lista2 n
  | n == 1 = lista1 ++ lista2
  | otherwise = (nadovezi lista1 lista2 (n-1)) ++ lista2
